#ifndef GRID_H
#define GRID_H

#include "common.cuh"


// na razie sa tutaj tylko pomocnicze funkcje, ale w przyszlosci pewnie trzeba bedzie dopisac fragmenty odpowiedzialne za stworzenie gridu na podstawie pliku wejsciowego

// wystapuja w funkcjach, wyznaczane po wczytaniu siatki modelu
__device__ int n_x_grid;
__device__ int n_y_grid;
__device__ int n_z_grid;

__device__ int n_grid_nodes;


// to powinno byc wczytywane z pliku konfiguracyjnego
// rozdzielczosc siatki
// TRZEBA WCZYTA
__device__ Precision h;


//constexpr Precision x_simulation_box = 1.0;
//constexpr Precision y_simulation_box = 1.0;
//constexpr Precision z_simulation_box = 1.0;

__host__ __device__ int grid_index_grid(int x, int y, int z);

__host__ __device__ void get_coordinates(int index, int& x, int& y, int& z);

__host__ __device__ void get_neighbors(int index, int* neighbors);

#endif