#ifndef NODE_H
#define NODE_H

#include "common.cuh"
//#include <limits>

struct Node {
    Vector x;
    Vector v;
    Vector f;
    Precision m;

    Vector v_old;

    Vector vector_dist;
    Precision dist;

    Node(Precision x, Precision y, Precision z) {
        this->x = Vector(x, y, z);
        this->v = Vector::Zero();
        this->m = 0;

        this->v_old = Vector::Zero();
    }
};

#endif