#ifndef COMMON_H
#define COMMON_H

#include <Eigen/Dense>
#include <cuda_runtime.h>
#include <device_launch_parameters.h>
#include<fstream>



#define M_PI 3.14159265358979323846

using Vector = Eigen::Vector3f; // zeby latwiej przejsc z 2d do 3d, z float na double, albo dac swoja implementacje macierzy i wektorow
using Matrix = Eigen::Matrix3f;
using Precision = float; // zeby latwo przejsc na double

// odcinanie za malych wartosci wag
constexpr Precision BSPLINE_EPSILON = 1e-4;


#endif
