#ifndef EMiTTER_H
#define EMiTTER_H

// tam na gorze, nie wiem, czemu i jest male, wezme poprawie pozniej

#include "common.cuh"
#include "obj_loader.cuh"

struct Emitter {

    Mesh mesh;
    Precision particle_initial_velocity;
    size_t particles_per_timestep;

    size_t starting_particle_index;
    size_t ending_particle_index;

    size_t starting_triangle_index;
    size_t ending_triangle_index; // chyba jest nieuzywane

    size_t n_triangles;

    Emitter(Mesh mesh, Precision particle_initial_velocity, size_t particles_per_timestep, size_t starting_particle_index) {
        this->mesh = mesh;
        this->particle_initial_velocity = particle_initial_velocity;
        this->particles_per_timestep = particles_per_timestep;
        this->starting_particle_index = starting_particle_index;
        this->ending_particle_index = starting_particle_index + particles_per_timestep;
        this->starting_triangle_index = 0;
        this->ending_triangle_index = 0;
        this->n_triangles = 0;
    }
};

#endif